\documentclass[a4paper,11pt]{article}

\usepackage[utf8x]{inputenc}
%\usepackage[czech]{babel}	%pro kompilaci LATEXem
%\usepackage{czech}		%pro kompilaci CSLATEXem

\usepackage{amsmath}
\usepackage{amsfonts}
\usepackage{amssymb}
\usepackage{amsthm}
\usepackage{graphicx}
\usepackage[usenames]{color}
\usepackage{hyperref}
\usepackage{url}
\usepackage{tikz}
\usetikzlibrary{arrows}
\usetikzlibrary{backgrounds}
\usetikzlibrary{decorations.pathmorphing}
\usetikzlibrary{graphs}
\usetikzlibrary{shapes.geometric}
\usetikzlibrary{calc}
\usetikzlibrary{patterns}
\usetikzlibrary{decorations.markings}
\usepackage{lettrine}
\usepackage{titlesec}
\usepackage{lipsum}
\usepackage{fancyhdr}
\usepackage{algorithm}
\usepackage{algorithmic}
\usepackage{listings}

%========== okraje stranky ====================================

\oddsidemargin 0.5cm 
\evensidemargin 0.5cm

\topmargin 3pt
\headheight 15pt
\headsep 20pt

\textwidth 13cm

\marginparwidth 3cm 
\marginparsep 0.5cm 

\textheight 21cm
\footskip 2cm
 
%============== nove prikazy a prostredi ============================

\newtheorem{example}{Example}[section]

%======================================================

\definecolor{cvutdarkblue}{RGB}{0,99,168}
\definecolor{cvutlighterblue}{RGB}{112,153,204}
\definecolor{cvutlightestblue}{RGB}{217,227,245}
\definecolor{light-gray}{gray}{0.75}

\lstset{language=Matlab, basicstyle=\scriptsize, keywordstyle=\color{blue}, backgroundcolor=\color{light-gray}}

%============== zahlavi a zapati ======================

\pagestyle{fancy}

\fancyhead{}
\rhead{\bfseries Lagrange's equation}

\fancyfoot{}
\rfoot{\thepage}
\lfoot{Lecture 6 on Modeling and Simulation of Dynamic Systems}

\renewcommand{\headrulewidth}{0.4pt}
\renewcommand{\footrulewidth}{0.4pt}

%\titleformat*{\section}{\fontfamily{pag}\fontsize{14pt}{16pt}\selectfont}
%============== opening ================================

\begin{document}

\thispagestyle{empty}

\begin{tikzpicture}[remember picture,overlay]

\coordinate [below=2.5cm] (midpoint) at (current page.north);

\node [name=colourbar,
draw=cvutlighterblue,
anchor=base,
fill=cvutlighterblue,
text = white,
minimum width=\paperwidth,
minimum height=1cm] at (midpoint) {};

% Define the point where the logo will go
\coordinate [right=20cm] (number) at (colourbar.west);

% Set coordinate system origin
\begin{scope}[shift=(number)]
% Draw the outline
\filldraw [cvutdarkblue] (1.3,0.5) -- ++(-2,0) -- ++(-0.8,-1) -- ++(2.8,0) --cycle;
% Include the logo
\node [text=white] {\Huge{\textbf{6}}};
\end{scope}

\end{tikzpicture}

%\vspace{-0.8cm}

\noindent
{\fontfamily{pag}\fontsize{31pt}{37pt}\selectfont Lagrange's equations}\\
\vspace{0.8cm}
{\fontfamily{pag}\fontsize{12pt}{12pt}\selectfont  Intro to an energy-based analytical modeling methodology}\\
\vspace{0.0cm}
\begin{flushright}{\fontfamily{pag}\fontsize{12pt}{14pt}\fontshape{it}\selectfont  Zden\v ek Hur\' ak}\\\today\end{flushright}
\vspace{0.8cm}

\lettrine{I}{n} this lecture we will step into the classical domain of energy-based modeling, which is centered around the famous differential equation: Lagrange's (also called Euler-Lagrange's) equation. In fact, there are two kinds of the equation and we call these accordingly---Lagrange's equation of the first and second kind. We will only lightly explain where these equations come from, mainly with the aim to develop a bit of insight, but our main focus in on learning how to use them for practical modeling. The modeling methodology has been described in gazzilions of textbooks and (downloadable) lecture notes but they mostly focus on mechanical systems. Since in our course we adhere strictly to the multidomain viewpoint---we want to use the given modeling methodology for mechanical as well as electronic and hydraulic systems---we will include a discussion of some related issues not commonly found in texts on theoretical/analytical/classical mechanics.

The essence of the methods is in evaluating the total kinetic and potential energies and or co-energies in the system. This can be a daunting task even for a system of a modest complexity if approached naively. Therefore in the next lecture we will introduce a systematic matrix-vector formalism for evaluating kinetic and potential energies of individual components of multibody mechanical systems. 


\section{Introduction, motivation}

Consider the simplest possible problem of modeling of a motion: a dimensionless object (a particle) of mass $m$ on which a force is acting in the vertical (upwards) direction and competing with the weight of the particle. See Fig.~\ref{fig:particle_vertical}.

\begin{figure}[h!]
\centering
 \includegraphics[width=5cm]{./figures/lagrange_motivation.pdf}
 % lagrange_motivation.pdf: 595x842 pixel, 72dpi, 20.99x29.70 cm, bb=0 0 595 842
\caption{Particle of mass $m$ in a gravitational field exposed to a force $F$ which competes with the weight $mg$.}
\label{fig:particle_vertical}
\end{figure}

The model of such a system, that is, the equation of motion of the particle, is given by the notoriously known second Newton's law
\begin{equation}
m\ddot y(t) = F(t) - mg. 
\end{equation}

Let's massage this familiar equation a bit. Express the left-hand side as
\begin{equation}
m\ddot y = \frac{\mathrm{d}}{\mathrm{d}t}\left(m\dot y \right)= \frac{\mathrm{d}}{\mathrm{d}t}\left(\frac{\partial}{\partial \dot y}\left(\underbrace{\frac{1}{2}m\dot y^2}_{\mathcal{T}} \right)\right),
\end{equation}
where $\mathcal T(\dot y)$ is the kinetic energy of the particle. Similarly, let us write the gravitational force as
\begin{equation}
-mg = -\frac{\partial}{\partial y}\left(mgy\right) = -\frac{\partial \mathcal V}{\partial y},
\end{equation}
where $\mathcal V(y)$ is the potential energy. Hence, the Newton's equation can be reformulated as
$$
\frac{\mathrm{d}}{\mathrm{d}t}\frac{\partial \mathcal T}{\partial \dot y}  + \frac{\partial \mathcal V}{\partial y} = F.
$$

Introducing a new auxiliary function called \textit{Lagrangian} and defined as 
\begin{equation}
\mathcal L(y,\dot y) = \mathcal T(\dot y)-\mathcal V(y),
\end{equation}
the Newton's equation finally turns into something as contrived as 
\begin{equation}
\frac{\mathrm{d}}{\mathrm{d}t}\frac{\partial \mathcal L(\dot y, y)}{\partial \dot y}  - \frac{\partial \mathcal L(\dot y, y)}{\partial y} = F(t),
\label{eq:lagrange_equation_particle}
\end{equation}
which we call Lagrange's (also Euler-Lagrange's) equation. 
 
What, on Earth, was the point in doing this massaging? Let's pretend for a second that we do not know the original equation of motion. We have just learnt that we can obtain it by evaluating the total kinetic and potential energies accumulated in the system, using them to form some special function called Lagrangian, and finally substituting this function into a special differential equation called by the same scientific giant. It turns out that we have derive the desired equation of motion by identifying correctly the energies in the system. This is the leitmotif for this lecture and the next.

\section{Kinetic and potential energy and coenergy}
We now need to spend some time with the very fundamental concept of energy. We already know that potential energy stored in the element called (generalized) compliance depends on the (generalized) displacement, while the kinetic energy accumulated in the (generalized) inertance depends on the velocity. The formula for kinetic energy $\mathcal{T} = 1/2m v^2$ is certainly one of the best notoriously known high-school physics formula. But the next paragraphs will show you that it is actually a bit more ivolved. 

Let's start with the potential energy. An element of type generalized compliance ties the following two variables through a generally nonlinear equation: the generalized force $e$ and the generalized velocity $f$. The equation comes in either of the two forms (with a tiny but common abuse of notation)
\begin{equation}
 e = e(q)
\end{equation}
or 
\begin{equation}
 q = q(e).
\end{equation}

The potential energy can be computed by integrating the instantaneous power over a time interval:
\begin{align}
 \mathcal{V} &= \int_{t_0}^{t_1} \mathcal{P}(t)\mathrm{d}t\nonumber\\
	      &= \int_{t_0}^{t_1} e(t)f(t)\mathrm{d}t \nonumber\\
	      &= \int_{t_0}^{t_1} e(t)\frac{\mathrm{d}q(t)}{\mathrm{d}t}\mathrm{d}t \nonumber\\
	      &= \int_{q_0}^{q_1} e(q)\mathrm{d}q,
\end{align}
where we assumed that no energy was accumulated in the system at the beginning of the time interval (the spring was relaxed, the capacitor uncharged, the hydraulic accumulator empty,\ldots). Upon relabeling, the formula for the potential energy is
\begin{equation}
 \mathcal{V}(q) = \int_{0}^{q} e(\tilde q)\mathrm{d}\tilde q.
\end{equation}

Obviously, the potential energy can be computed as the area under the graph of the function $e(q)$ as the Fig.~\ref{fig:potential_coenergy} suggests
\begin{figure}[ht]
 \centering
 \includegraphics[width=6cm]{./figures/potential_coenergy.pdf}
 % potential_coenergy.pdf: 0x0 pixel, 300dpi, 0.00x0.00 cm, bb=
 \caption{Potential energy and coenergy}
 \label{fig:potential_coenergy}
\end{figure}

We also label the area above the graph using the symbol $\mathcal{V}*$ and call it a \textit{potential coenergy}. Although it has no physical meaning, it can be useful computationally. Note that 
\begin{equation}
 \mathcal{V}(q) = e q -\mathcal{V}^*(e).
\end{equation}

This relationship between the energy and coenergy is an instance of the use of the Legandre transform.

Recall that for a linear compliance $e = \frac{1}{C}q$, hence 
\begin{equation}
 \mathcal{V}(q) = \int_{0}^{q} \frac{1}{C}\tilde q\mathrm{d}\tilde q = \frac{1}{2}\frac{1}{C}q^2
\end{equation}
and the potential energy can be computed simply as the area of the lower triangle in Fig.~\ref{fig:potential_coenergy_linear}.
\begin{figure}[ht]
 \centering
 \includegraphics[width=6cm]{./figures/potential_coenergy_linear.pdf}
 % potential_coenergy.pdf: 0x0 pixel, 300dpi, 0.00x0.00 cm, bb=
 \caption{Potential energy and coenergy for a linear compliance}
 \label{fig:potential_coenergy_linear}
\end{figure}

Obviously in this case we have $\mathcal{V} = \mathcal{V}^*$ and there is no need to distinguish between $\mathcal{V}$ and $\mathcal{V}^*$ computationally.

The story goes along the same line in the case of an accumulator of a kinetic energy---a generalized inertance. Recall that in the nonlinear case such element is characterized by a relatinship between the generalized momentum $p$ and the generalized velocity $f$ as sketched in Fig.~\ref{fig:kinetic_coenergy}.
\begin{figure}[ht]
 \centering
 \includegraphics[width=6cm]{./figures/kinetic_coenergy.pdf}
 % potential_coenergy.pdf: 0x0 pixel, 300dpi, 0.00x0.00 cm, bb=
 \caption{Kinetic energy and coenergy for a linear inertance}
 \label{fig:kinetic_coenergy}
\end{figure}

Hence the graph corresponds to either of the two equations
\begin{equation}
 p = p(f)
\end{equation}
or
\begin{equation}
 f = f(p).
\end{equation}

One of the above two equations will have to be used while evaluating the kinetic energy by integrating the power over a time inverval
\begin{align}
 \mathcal{V} &= \int_{t_0}^{t_1} \mathcal{P}(t)\mathrm{d}t\nonumber\\
	      &= \int_{t_0}^{t_1} e(t)f(t)\mathrm{d}t \nonumber\\
	      &= \int_{t_0}^{t_1} f(t)\frac{\mathrm{d}p(t)}{\mathrm{d}t}\mathrm{d}t \nonumber\\
	      &= \int_{p_0}^{p_1} f(p)\mathrm{d}p.
\end{align}

Relabeling and considering zero momentum at the beginning of the interval we get the ultimate formula 
\begin{equation}
 \mathcal{T}(p) = \int_{0}^{p} f(\tilde p)\mathrm{d}\tilde p.
\end{equation}

The kinetic energy can be visualized as the area under the graph of dependence of velocity on the momentum in Fig.~\ref{fig:kinetic_coenergy}. Similarly as in the potential energy case we can define the complement to the rectangular area as the kinetic coenergy $\mathcal{T}*(f)$.

In the linear case, the relevant relationship is $f = \frac{1}{I}p$, and the energy is 
\begin{equation}
 \mathcal{T}(p) = \int_{0}^{p} \frac{1}{I}\tilde p\mathrm{d}\tilde p = \frac{1}{2}\frac{1}{I}p^2.
\end{equation}

This can also be visualized as the area of the lower triangle in Fig.~\ref{fig:kinetic_coenergy_linear}. 
\begin{figure}[ht]
 \centering
 \includegraphics[width=6cm]{./figures/kinetic_coenergy_linear.pdf}
 % potential_coenergy.pdf: 0x0 pixel, 300dpi, 0.00x0.00 cm, bb=
 \caption{Kinetic energy and coenergy for a linear inertance}
 \label{fig:kinetic_coenergy_linear}
\end{figure}

Of course, it is numerically equal to the area of the upper triangle, but this happens only in the linear case. Switching temporarily to the symbols popular in the mechanical domain, we then have 
\begin{equation}
 \mathcal{T}(p) = \frac{1}{2}\frac{1}{m}p^2 =  \frac{1}{2}m v^2 = \mathcal{T}^*(v).
\end{equation}

Hence, our old friend, the expression $\frac{1}{2}m v^2$ actually stands for kinetic coenergy and not energy, albeit these are numerically equal in the linear case. 

The distinction between the energies and coenergies will be vital in the next section when we introduce Lagrange's equation. Note that you will not find this discussion in most textbooks since they are mostly oriented towards modeling of mechanical systems and unless the velocity of motion approaches the speed of light, the velocity remains nicely proportional to the momentum ($p = mv$). In fact, it was already in our introductory example that we mislabeled the kinetic coernergy for kinetic energy (remember that it is the kinetic coenergy that depends on the generalized velocity), but in this mechanical case the distinction simply played no role.

But as soon as we start considering accumulators of kinetic energy in magnetic field, that is, electric inductors, in particular inductors with iron cores, the dependence of $f$ on $p$ turns nonlinear, featuring saturation and also hysteresis.

\section{Constraints}
In the modeling techniques that we are about to introduce, we need to characterize the configuration of the system. At first it might seem that in order to characterize the system fully, a set of six dedicated coordinates must be given for each moving part (three coordinates for translation and three for rotation). For a robotic arm consisting of four links interconnected with three joints it appears that 24 coordinates are perhaps needed. Obviously, one could do away with significantly lower number of coordinates. Say, the angles in the four motorized joints of the robotic arm. Four instead of 24. A major reduction. Moreover, the particular modeling technique based on the Lagrange's equation requires that not dependency among the coordinates exists. Apparently, the original set of 24 variables was strongly intercoupled, hence not suitable for modeling using Lagrange's equation. The new set of four variables (joint angles) satisfies constitutes the so-called \textit{generalized coordinates}. We have to discuss these. 

First, however, we need to classify \textit{constraints}. In the introductory example, the particle in the free air was not constrained at all. In order to characterize its position, we needed three coordinates: $x$, $y$ and $z$ (the three rotation angles were irrelevant here since we assume a dimensionless point). We will follow the notational convention that these are grouped in a column vector and we will add a lower index 1 in order to distinguish this particle and its coordinates from what is to come
\begin{equation}
 \mathbf{r}_1 = \begin{bmatrix}
                 x_1 \\ y_1 \\ z_1
                \end{bmatrix}.
\end{equation}

As soon as we start considering some nonnegligible volume of the object, we will also need to consider three more coordinates for the orientation. 

With the exception of studying dynamics of some space vehicles such as satellites, which can move freely in the three-dimensional space, the motion of mechanical objects will be constrained in some sense. There may be two origins of these mechanical constraints

\begin{itemize}
 \item constraints that restrict the motion of the objects to some subset of the full 3D space (vehicle traveling on the ground, bead sliding on a rigid wire,  ...),
 \item constraints due to coupling with other objects (as a limiting case, rigid body can be viewed as a set of mutually coupled particles).
\end{itemize}

As an simple example of the former, we now seat the particle 1 on a table and we only consider its motion over the surface of the table. Doing this we have imposed a \textit{constraint} 
\begin{equation}
 z_1 = 0.
\end{equation}

As a consequence of the constraint, the number of independent variables among the three coordinates shrinks to from 3 to 2.

As an example of the latter, consider two particles, label them 1 and 2 and their masses are $m_1$ and $m_2$, respectively. Their positions are characterized by the coordinate triples 
\begin{equation}
 \mathbf{r}_1 = \begin{bmatrix}
                 x_1 \\ y_1 \\ z_1
                \end{bmatrix}
\end{equation}
and 
\begin{equation}
 \mathbf{r}_2 = \begin{bmatrix}
                 x_2 \\ y_2 \\ z_2
                \end{bmatrix}
\end{equation}
respectively. We will introduce here conveniently the concept of a \textit{configuration space} by simply stacking the two vectors on top of each other
\begin{equation}
 \mathbf{r} = \begin{bmatrix}
                 x_1 \\ y_1 \\ z_1\\ x_2 \\ y_2 \\ z_2
                \end{bmatrix}.
\end{equation}

We see that we need in total 6 variables to characterize the mechanical configuration of a two-particle system. We say that \textit{the dimension of the configuration space is 6}. Now we connect these two with a massless rigid rod of length $l$. This way we introduced a constraint
\begin{equation}
 (x_1-x_2)^2 + (y_1-y_2)^2 + (z_1-z_2)^2 = l^2.
\end{equation}

We again observe that by considering the constraint, we introduced some dependence among the six variables. These six variables are no longer independent. In fact, every constraint reduces by one the number of independent variables that were originally used to characterize the mechanical configuration. We say, that each constraint reduces the \textit{number of degrees of freedom}. 

Combining the two examples above into one, we just connect to particles by a massless rod and place it on a surface of a table. By imposing the three constraints, we reduce the number of degrees of freedom to three.

Seeing this dependence among the variables, a natural quest is to replace the original (long) list of coordinates by a shorter one that will do the same job of fully characterizing the mechanical configuration. It seems reasonable to expect that three variables will suffice. In other words, we aim at expressing the original six variables by just three. With some abuse of notation we relabel the original coordinates to $x_1, x_2, x_3, \ldots, x_6$ and then
\begin{align}
 x_1 &= x_1(q_1,q_2,q_3),\\
 x_2 &= x_2(q_1,q_2,q_3),\\
 \vdots\\
  x_6 &= x_1(q_1,q_2,q_3).
\end{align}

In general we will have
\begin{align}
 x_1 &= x_1(q_1,q_2,\ldots, q_n),\\
 x_2 &= x_2(q_1,q_2,\ldots, q_n),\\
 \vdots\\
  x_{3N} &= x_{3N}(q_1,q_2,\ldots, q_n),
\end{align}
where $N$ is the number of particles and $n$ is the smallest possible number of generalized coordinates, which is defined as the smallest possible dimension of the generalized configuration space. In our example it coincides with the number of degrees of freedom, which inherently means that the $q_k$ variables are independent.

Considering once again the two particles on a table interconnected with a massless rod, reasonable candidates for the three generalized coordinates follow from Fig.~\ref{fig:two_beads_massless_rod_generalized_coordinates}

\begin{figure}[h!]
\centering
\includegraphics[width=5cm]{./figures/two_beads_massless_rod_generalized_coordinates.pdf}
 % two_beads_massless_rod_generalized_coordinates.pdf: 595x842 pixel, 72dpi, 20.99x29.70 cm, bb=0 0 595 842
\caption{Candidates for the three generalized coordinates for a system consisting of two particles connected by a massless rod.}
\label{fig:two_beads_massless_rod_generalized_coordinates} 
 \end{figure}

\begin{equation}
 \mathbf q = \begin{bmatrix}q_1\\q_2\\q_3\end{bmatrix} = \begin{bmatrix}x_1\\y_2\\\theta\end{bmatrix}.
\end{equation}

Let us restate our observations so far. By exposing the system to additional mechanical constraints, a dependence among the coordinate variables is introduced, which we characterize as a drop in the degrees of freedom. Simultaneously, a drop in the number of degrees of freedom is accompanied by a reduction in the dimension of configuration space, that is, the number of coordinate variables we need to fully characterize the system. 

However, is it guaranteed that it will always work like that? Can we rely on the fact that every constraint reduces the number of the configuration space? Unfortunately no! We were lucky with our introductory examples because these belonged to the friendly family of so-called holonomic constraints. There are, however, some unfriendly constraints, which do not obey this rule.

\section{Holonomic constraints}

A general form for the holonomic mechanical constraint is
\begin{equation}
 g(x_1,x_2,\ldots,x_{3N},t) = 0.
\end{equation}

Note that we also make provisions for $g$ depending explicitly on time. Now, in principle we could now use this equation and express one of the coordinate variables as a function of the rest. Well, we could run into some algebraic difficulties. Moreover, this is rarely done because, as you have seen previously, we may want to choose as the generalized variables something different from those original coordinates. Anyway, in principle this could be done. Furthemore, there is no problem to convert the constraints on the coordinates into the constraints on velocities. Simply differentiate both sides by $t$. Note that we have to apply the chain rule for differentiation since we have a composed function here: $g$ is a function of $x_k$, but $x_k$ is a function of $t$
\begin{equation}
\frac{\mathrm{d}g}{\mathrm{d}t} = \sum_{k=1}^{3N} \frac{\partial g}{\partial x_k} \frac{\mathrm d x_k}{\mathrm d t} + \frac{\partial g}{\partial t} = 0. 
\end{equation}

What we found above is actually the \textit{total derivative}. We can also view this constraint from yet another viewpoint
\begin{equation}
\mathrm{d}g = \sum_{k=1}^{3N} \frac{\partial g}{\partial x_k} \mathrm d x_k + \frac{\partial g}{\partial t}\mathrm d t = 0. 
\label{eq:total_differential}
\end{equation}

Surely you are recognizing a \textit{total (also exact) differential} here. To summarize, the holonomic constraints can be equally well expressed in coordinates, velocities and differentials.

\section{Nonholonomic constraints}

Nonholonomic constraints typically come as constraints purely on velocities, most probably than not just as linear functions
\begin{equation}
 \sum_{k=1}^{3N} a_k \frac{\mathrm d x_k}{\mathrm{d}t} + a_t = 0.
\end{equation}

Equivalently we can view the above constraint as a constraint on differentials
\begin{equation}
\sum_{k=1}^{3N} a_k \mathrm d x_k + a_t\mathrm{d}t = 0.
\label{eq:inexact_differential}
\end{equation}

The troubles with nonholonomic constraints is that they cannot be converted (by integration) into constraints on coordinates! In other words, the expression on the left of (\ref{eq:inexact_differential}) cannot be integrated.

How can we tell just from the coefficients in the constraint if it is holonomic or nonholonomic? If the left hand side of (\ref{eq:inexact_differential}) represents a total differential, the coefficient $a_k$ is necessarily a partial derivative of some $g$, see (\ref{eq:total_differential}). But then it must hold that 
\begin{equation}
 \frac{\partial a_i}{\partial x_j}=\frac{\partial a_j}{\partial x_i} \text{  for all } i\neq j.
\end{equation}

As an example of a nonholonomic system, let us consider extension of our two-particle-one-massless-rod-on-a-table system, which will consist in attaching ice skates to the two particles as in Fig.~\ref{fig:skating_rod}. 
\begin{figure}[h!]
\centering
 \includegraphics[width=5cm]{./figures/two_beads_massless_rod_with_skates.pdf}
 % two_beads_massless_rod_with_skates.pdf: 595x842 pixel, 72dpi, 20.99x29.70 cm, bb=0 0 595 842
 \label{fig:skating_rod}
\end{figure}

As a consequence of this new constraint, the system can only move in such a way, that the instantaneous velocity of, say, the center of the rod must by orthogonal to the rod. Note that this certainly does not mean that the rod can only follow straight lines. It can follow curved trajectories, the constraint is on the instantaneous velocity. Your experience from ice skating can support this (of course, it is assumed that skidding is avoided). It is straightforward to construct the constraint function for this scenario. Finding the constraint on differentials seems a bit more convenient
\begin{equation}
\mathrm{d}x = - \frac{\sin \alpha}{\cos \alpha} \mathrm{d}y, 
\end{equation}
which can be modified to
\begin{equation}
\cos \alpha \mathrm{d}x + \sin \alpha \mathrm{d}y = 0. 
\end{equation}

The left hand side in the equation above is not a total differential (check by yourself), hence the constraint is not holonomic. Finally, you may want to see how the constraint on the velocities look like
\begin{equation}
\frac{\mathrm{d}x}{\mathrm{d}t} = - \frac{\sin \alpha}{\cos \alpha} \frac{\mathrm{d}y}{\mathrm{d}t}. 
\end{equation}

Innocent, and yet it cannot be transformed (integrated) into a constraint on coordinates. Therefore, this ``skating constraint'' did steal one degree of freedom (two are now left) but the dimension of the configuration space is still three and there is no way to reduce it. Indeed, we still need three coordinate variables to fully characterize the mechanical configuration and yet these three are not independent. This interdependence of variables is a major trouble in further theoretical derivations of modeling methodology based on Lagrange's equation. Although we will not prove it in this course (we direct students for derivations elsewhere), Lagrange's equation does need independence of coordinate variables! Keep this in mind. 

Another example of a nonholonomic system is a disk rolling over a flat surface without a slipping and skidding as in Fig.~\ref{fig:disk_rolling_on_surface}.
\begin{figure}
 \center
 \includegraphics[width=5cm]{./figures/disk_rolling_on_surface.pdf}
 % disk_rolling_on_surface.pdf: 595x842 pixel, 72dpi, 20.99x29.70 cm, bb=0 0 595 842
 \caption{Another example of a nonholonomic system: a disk rolling on a flat surface without slipping and skidding. Four coordinate variables are needed but the number of degrees of freedom is three due to the nonholonomic constraint on the direction of the instantaneous velocity.}
 \label{fig:disk_rolling_on_surface}
\end{figure}

Nonholonomic systems are a daily bread for mobile robotists and vehicular dynamics engineers. 

\section{Lagrange's (also Euler-Lagrange's) equation for holonomic systems}
The equation (\ref{eq:lagrange_equation_particle}) is just an instance of \textit{Lagrange's equation} (also Euler-Lagrange's equation or ELE)
\begin{equation}
\frac{\mathrm{d}}{\mathrm{d}t} \frac{\partial \mathcal L(\dot q, q, t)}{\partial \dot q_i} - \frac{\partial \mathcal L(\dot q, q, t)}{\partial q_i} = Q_k,\qquad k=1,2,\ldots,n.
\label{eq:lagrange_equation}
\end{equation}
where \textit{Lagrangian} $\mathcal L(\dot q, q, t)$ is difference between kinetic coenergy and potential energy expressed 
\begin{equation}
\mathcal L(\dot q, q, t) = \mathcal T^*(\dot q, q, t) - \mathcal V (q)
\end{equation}
and $Q_k$ are \textit{generalized forces} which are not derived from a potential energy function. In other words, if the force acting in the direction of the $q_k$ coordinate is given by $-\frac{\partial \mathcal V}{\partial q}$, it will not appear on the right hand side of (\ref{eq:lagrange_equation}). Instead it has already been included in the corresponding term on the left-hand side. The term $Q_k$ on the right-hand side is reserved for \textit{nonconservative forces} such as friction or the externally inputs (controls, disturbances). We will discuss these in a while.

The energies were expressed as functions of the \textit{generalized coordinates} $q=(q_1,q_2,\ldots,q_n)$ and the \textit{generalized velocities} $\dot q=(\dot q_1,\dot q_2,\ldots,\dot q_n)$. This assumes that all the $q_i$'s are independent. This automatically excludes systems with nonholonomic constraints. Furthermore, all the holonomic constraints had to be used to reduced the dimension of the configuration space to the smallest dimension possible. Otherwised the ELE equation in the above format will not be valid.  

Another assumptions of this equation is that the potential energy is a function of a generalized coordinates only and not of generalized velocity, that is, we write $\mathcal V(q)$. This is automatically satisfied in mechanics, but can be broken in electromagnetism. 

The equation (\ref{eq:lagrange_equation}) certainly belongs into top-ten results/concepts in applied mathematics and although we do not cover a proof of this result, we strongly encourage interested students to look up one elsewhere and study it.

\section{Simple examples}
In this section we will show how to apply the modeling technique based on Lagrange's equation to find the equation(s) of motion for some simple mechanical systems. As is becoming clear, the key task in modeling is to evaluate the total kinetic and potential energies in the system. 

\subsection{Mass-spring-damper system}

As the first example that only slightly complicates our trivial example with a particle in the free air, consider the setup in Fig.~\ref{fig:single_mass_spring_damper}. An object of mass $m$ is hanging on a spring with stiffness $k$ and a viscous damper with the coefficient $b$.
\begin{figure}[ht]
 \centering
 \includegraphics[width=4cm]{./figures/single_mass_spring_damper.pdf}
 % single_mass_spring_damper.pdf: 595x842 pixel, 72dpi, 20.99x29.70 cm, bb=0 0 595 842
 \caption{Single mass attached by a spring and a damper.}
 \label{fig:single_mass_spring_damper}
\end{figure}

As a natural candidate for the generalized coordinate, the prolongation $x$ of the mass can be chosen. Note that if a non negligible size of the object is considered, one would have to be more accurate as for the exact definition of the distance. Now the task is to determine the kinetic coenergy and potential energy. Kinetic coenergy is trivial:
\begin{equation}
 \mathcal T^* = \frac{1}{2}m\dot x^2.
\end{equation}

The potential energy is composed of two parts: energy accumulated in the spring and energy related to the elevation of the mass in the gravitational field:
\begin{equation}
 \mathcal{V} = \frac{1}{2}kx^2 - mgx.
\end{equation}

The Lagrangian is 
\begin{equation}
 \mathcal L(x,\dot x) = \frac{1}{2}m\dot x^2 - \frac{1}{2}kx^2 + mgx.
\end{equation}

Before we are ready to substitute into the Lagrange's equation, we have to determine its right hand side, that is the nonconservative forces. The only nonconservative force acting on the object is the friction
\begin{equation}
 Q = -b\dot x(t).
\end{equation}

Note the minus sign, which just tells that the friction acts against the motion. Lagrange's equation can now be written as
\begin{equation}
 m\ddot x(t) + kx(t) - mg = -b\dot x(t),
\end{equation}
which is our desired equation of motion.

\subsection{Multiple mass-spring-damper system}

Now, let us extend the previous example with an additional mass, spring and damper as in Fig.~\ref{fig:double_mass_spring_damper}. 
\begin{figure}[ht]
 \centering
 \includegraphics[width=4cm]{./figures/double_mass_spring_damper.pdf}
 % single_mass_spring_damper.pdf: 595x842 pixel, 72dpi, 20.99x29.70 cm, bb=0 0 595 842
 \caption{Double masses attached by springs and dampers.}
 \label{fig:double_mass_spring_damper}
\end{figure}

The important decision that needs to be made at the beginning is the definition of the second generalized coordinate. One candidate is the ``global coordinate'', that is, the distance from the ``ceiling''. Another candidate is the relative one, that is, the distance between the two masses. Both options are fine, but they will have an impact on how we will evaluate the energies. Very often we choose the generalized coordinates based on the availability of measurements in our real system; after all, our ultimate use of the mathematical model is to support the controller design. The former option will be appropriate if the positions of the two masses are measured using a computer vision system. The latter option is appropriate if the distance between the masses is evaluated by, say, measuring the reflected IR light emitted by a photodiode or any other kind of a displacement sensor.

The kinetic coenergy is easy, but keep in mind the above discussion of the definitions of generalized coordinates. Whichever choice you make, kinetic energy is only determined by the absolute velocity

\begin{equation}
 \mathcal T^* = \mathcal{T}_1^* + \mathcal{T}_2^* =  \frac{1}{2}m_1\dot x_1^2 + \frac{1}{2}m_2({\color{red}\dot x_1+\dot x_2})^2.
\end{equation}

This point is of the uppermost importance! We will bump into it a couple of times while solving other examples. But you can already feel quite comfortable about it since you already experienced this with bond graphs where generalized inertances accumulate energy related to the absolute velocity---inertances are directly bonded to the type-1 junctions. 

While determining the potential energy, we have to make the same type of analysis---does the accumulated energy correspond to the absolute or relative position? 

\begin{align}
 \mathcal{V} &= \mathcal{V}_1 + \mathcal{V}_2\nonumber\\
             &= \frac{1}{2}k_1x_1^2 - mgx_1 + \frac{1}{2}k_2{\color{red}x_2}^2 - mg({\color{red}x_1+x_2}). 
\end{align}

Here, apparently the energy accumulated in the second spring corresponds to the relative displacement whereas the energy due to elevation in the gravitational field corresponds to the absolute position.

Substituting into the Lagrange's equation we get the motion equations. Since there are two generalized coordinates, there are two Lagrange equations

\begin{align}
\frac{\mathrm d}{\mathrm d t}\frac{\partial \mathcal T^*}{\partial \dot x_1} + \frac{\partial \mathcal V}{\partial x_1} = Q_1,\\
\frac{\mathrm d}{\mathrm d t}\frac{\partial \mathcal T^*}{\partial \dot x_2} + \frac{\partial \mathcal V}{\partial x_2} = Q_2.
\end{align}

Upon substitution of the energies and the friction forces we obtain

\begin{align}
(m_1+m_2)\ddot x_1 + m_2\ddot x_2 + k_1x_1 - (m_1+m_2)g &= -b_1\dot x_1 + b_2\dot x_2,\\
m_2x_1 + m_2x_2 + k_2 x_2 - m_2g &= -b_2 \dot x_2.
\end{align}

\subsection{Pendulum on a massless rod}

Consider the standard textbook-style pendulum as in Fig.~\ref{fig:single_pendulum}.

\begin{figure}[ht]
 \centering
 \includegraphics[width=4cm]{./figures/single_pendulum_bob.pdf}
 % single_pendulum_bob.pdf: 595x842 pixel, 72dpi, 20.99x29.70 cm, bb=0 0 595 842
 \caption{Single pendulum (a particle of mass $m$ and a massless rod).}
 \label{fig:single_pendulum}
\end{figure}

A natural candidate for a generalized coordinate is the angle $\theta$. We now need to express the kinetic coenergy and potential energy as functions of $\theta$ and $\dot \theta$.

\begin{equation}
 \mathcal T^* = \frac{1}{2}mv^2 = \frac{1}{2}m(l\dot \theta)^2 = \frac{1}{2}ml^2\dot \theta^2
\end{equation}

\begin{equation}
\mathcal{V} = -mgy = -mg\cos\theta l. 
\end{equation}

Substituting in the Lagrange's equation we get

\begin{equation}
ml^2\ddot \theta(t) + mgl\sin\theta(t) = 0,
\end{equation}
which simplifies to the well-known differential equation
\begin{equation}
\ddot \theta(t) + \frac{g}{l}\sin\theta(t) = 0.
\end{equation}

\subsection{A bead in a rotating circular tube---and example of a rheonomic (=time-varying) constraint}

We consider the hollow tube shaped into a circle. The circle is rotating around a vertical axis at a given speed. Inside the tube there is a particle of mass $m$ which slides without a friction, see Fig.~\ref{fig:rheonomic_circular}. 
\begin{figure}[h!]
\centering
\includegraphics[width=4cm]{./figures/rheonomic_circular.pdf}
 % rheonomic_circular.pdf: 595x842 pixel, 72dpi, 20.99x29.70 cm, bb=0 0 595 842
\caption{An example of a system with rheonomic (=time-varying) constraints. A bead in a rotating circuilar tube.}
\label{fig:rheonomic_circular}
 \end{figure}

When deriving the kinetic coenergy as a function of the single generalized variable $\theta$, we must keep in mind that the kinetic energy corresponds to the motion with respect to the inertial space, not just with respect to the tube. 
\begin{align}
\mathcal T^* &= \frac{1}{2}mr^2\left(\dot \theta^2 + \omega^2\sin^2\theta\right),\\
\mathcal V &= mgr\cos \theta.
\end{align}

We will conclude this example by writing down the Lagrangian. The rest is straightforward and you are asked to find the motion equation and possibly simulate the model to get some insight. 
\begin{equation}
\mathcal L = \frac{1}{2}mr^2\left(\dot \theta^2 + \omega^2\sin^2\theta\right) - mgr\cos \theta.
\end{equation}
 
\section{Literature}
The topic discussed in this lecture constitutes the core of every advanced course on dynamics or theoretical/analytical mechanics. There are a wealth of resources, including those freely available online. We can recommend the lecture notes \cite{kulhanek_2011} written in Czech. Do not let the dedication to doctoral students repulse you. No doubt you can follow most of the exposition there. Indeed, this is a very nice intro to Lagrange' and Hamilton's approach to modeling dynamical systems.

As for the English written materials, I can warmly recommend \cite{greenwood_advanced_2006}, although I am not aware of a legally available downloadable version. It is a very accessible and yet rigorous treatment. A previous version \cite{greenwood_classical_1997} is very famous and actually also fairly cheep (USD11 on amazon.com). I used the book for preparation of this lecture. Another high quality classical and yet cheap book is \cite{lanczos_variational_1970}.

All the above recommended books are written by physicists and mathematicians. As a consequence, they are rather general and abstract, with the main focus on principles rather than on practical situations. Should you desire some practical cookbook, you should certainly look for some robotics textbook. My favorite is \cite{spong_robot_2005}. Its chapter seven is dedicated to modeling. Besides the Lagrange's technique, the alternative Newton-Euler's technique is covered too. Alternatively, \cite{sicilliano_robotics_2009} can do the same job. Having one of these two robotics classics on a bookshelf is highly recommendable for a student aspiring to become a robotics guru.

% Velmi stručný úvod do problematiky využití Lagrangeových rovnic pro modelování holonomních dynamických systémů lze najít v několikastránkové sekci 12.3 v Brownově knize. Zhruba na této úrovni se pokusíme danou problematiku zvládnout, i přestože se nebudeme držet striktně podání v této knize. Brown dále pokračuje v sekci 12.4 zkombinováním analytických výsledků pro Lagrangeovu rovnici s metodikou vazebních grafů, ale tam se my již společně pouštět nebudeme.

In this lecture we paid attention to distinguishing between energies and coenergies. This could hardly be justified with purely mechanical systems since it only contributes to the notational clutter. But our motivation is to apply the same technique to modeling of electronic and electromechanical system and that is where this distinction is vital. We strongly recommend a relatively recent tutorial paper on this topic \cite{jeltsema_multidomain_2009}. Similarly, we only recently came across the textbook on Lagrange-equation-based modeling in mechatronics \cite{preumont_mechatronics_2006}, which seems to share our multidomain modeling viewpoint. 

\bibliographystyle{plain}
\bibliography{../msd}
 

\end{document}
